Package com.google.protobuf

# Class GeneratedMessage.Builder<BuilderType extends GeneratedMessage.Builder<BuilderType>>

java.lang.Object
com.google.protobuf.AbstractMessageLite.Builder
com.google.protobuf.AbstractMessage.Builder<BuilderType>
com.google.protobuf.GeneratedMessage.Builder<BuilderType>

All Implemented Interfaces:
  `Message.Builder`, `MessageLite.Builder`, `MessageLiteOrBuilder`, `MessageOrBuilder`, `Cloneable`

Direct Known Subclasses:
  `GeneratedMessage.ExtendableBuilder`

Enclosing class:
  GeneratedMessage

public abstract static class GeneratedMessage.Builder<BuilderType extends GeneratedMessage.Builder<BuilderType>> extends AbstractMessage.Builder<BuilderType>

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`Builder()`
`protected`
`Builder(GeneratedMessage.BuilderParent builderParent)`

## Method Summary

Modifier and Type
Method
Description
`BuilderType`
`addRepeatedField(Descriptors.FieldDescriptor field, Object value)`
Like `setRepeatedField`, but appends the value as a new element.
`BuilderType`
`clear()`
Called by the initialization and clear code paths to allow subclasses to reset any of their builtin fields back to the initial values.
`BuilderType`
`clearField(Descriptors.FieldDescriptor field)`
Clears the field.
`BuilderType`
`clearOneof(Descriptors.OneofDescriptor oneof)`
TODO(jieluo): Clear it when all subclasses have implemented this method.
`BuilderType`
`clone()`
Clones the Builder.
`Map<Descriptors.FieldDescriptor,Object>`
`getAllFields()`
Returns a collection of all the fields in this message which are set and their corresponding values.
`Descriptors.Descriptor`
`getDescriptorForType()`
Get the message's type's descriptor.
`Object`
`getField(Descriptors.FieldDescriptor field)`
Obtains the value of the given field, or the default value if it is not set.
`Message.Builder`
`getFieldBuilder(Descriptors.FieldDescriptor field)`
Get a nested builder instance for the given field.
`Descriptors.FieldDescriptor`
`getOneofFieldDescriptor(Descriptors.OneofDescriptor oneof)`
TODO(jieluo): Clear it when all subclasses have implemented this method.
`protected GeneratedMessage.BuilderParent`
`getParentForChildren()`
Gets the `GeneratedMessage.BuilderParent` for giving to our children.
`Object`
`getRepeatedField(Descriptors.FieldDescriptor field, int index)`
Gets an element of a repeated field.
`Message.Builder`
`getRepeatedFieldBuilder(Descriptors.FieldDescriptor field, int index)`
Get a nested builder instance for the given repeated field instance.
`int`
`getRepeatedFieldCount(Descriptors.FieldDescriptor field)`
Gets the number of elements of a repeated field.
`final UnknownFieldSet`
`getUnknownFields()`
Get the `UnknownFieldSet` for this message.
`boolean`
`hasField(Descriptors.FieldDescriptor field)`
Returns true if the given field is set.
`boolean`
`hasOneof(Descriptors.OneofDescriptor oneof)`
TODO(jieluo): Clear it when all subclasses have implemented this method.
`protected abstract GeneratedMessage.FieldAccessorTable`
`internalGetFieldAccessorTable()`
Get the FieldAccessorTable for this type.
`protected MapField`
`internalGetMapField(int fieldNumber)`
Gets the map field with the given field number.
`protected MapField`
`internalGetMutableMapField(int fieldNumber)`
Like `internalGetMapField(int)` but return a mutable version.
`protected boolean`
`isClean()`
Gets whether invalidations are needed
`boolean`
`isInitialized()`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.
`protected void`
`markClean()`
Called by the subclass or a builder to notify us that a message was built and may be cached and therefore invalidations are needed.
`BuilderType`
`mergeUnknownFields(UnknownFieldSet unknownFields)`
Merge some unknown fields into the `UnknownFieldSet` for this message.
`Message.Builder`
`newBuilderForField(Descriptors.FieldDescriptor field)`
Create a builder for messages of the appropriate type for the given field.
`protected void`
`onBuilt()`
Called by the subclass when a message is built.
`protected final void`
`onChanged()`
Called when a the builder or one of its nested children has changed and any parent should be notified of its invalidation.
`protected boolean`
`parseUnknownField(CodedInputStream input, UnknownFieldSet.Builder unknownFields, ExtensionRegistryLite extensionRegistry, int tag)`
Called by subclasses to parse an unknown field.
`BuilderType`
`setField(Descriptors.FieldDescriptor field, Object value)`
Sets a field to the given value.
`BuilderType`
`setRepeatedField(Descriptors.FieldDescriptor field, int index, Object value)`
Sets an element of a repeated field to the given value.
`BuilderType`
`setUnknownFields(UnknownFieldSet unknownFields)`
Set the `UnknownFieldSet` for this message.

### Methods inherited from class com.google.protobuf.AbstractMessage.Builder

`findInitializationErrors, getInitializationErrorString, getUnknownFieldSetBuilder, internalMergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, newUninitializedMessageException, setUnknownFieldSetBuilder, toString`

### Methods inherited from class com.google.protobuf.AbstractMessageLite.Builder

`addAll, addAll, mergeDelimitedFrom, mergeDelimitedFrom, mergeFrom, newUninitializedMessageException`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.protobuf.Message.Builder

`build, buildPartial, mergeDelimitedFrom, mergeDelimitedFrom`

### Methods inherited from interface com.google.protobuf.MessageLite.Builder

`mergeFrom`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`getDefaultInstanceForType`

## Constructor Details

### Builder

protected Builder()

### Builder

protected Builder(GeneratedMessage.BuilderParent builderParent)

## Method Details

### onBuilt

protected void onBuilt()
Called by the subclass when a message is built.

### markClean

protected void markClean()
Called by the subclass or a builder to notify us that a message was built and may be cached and therefore invalidations are needed.

### isClean

protected boolean isClean()
Gets whether invalidations are needed

Returns:
  whether invalidations are needed

### clone

public BuilderType clone()
Description copied from interface: `MessageLite.Builder`
Clones the Builder.

Specified by:
  `clone` in interface `Message.Builder`
Specified by:
  `clone` in interface `MessageLite.Builder`
Overrides:
  `clone` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessage.Builder<BuilderType>>`
See Also:
  - `Object.clone()`

### clear

public BuilderType clear()
Called by the initialization and clear code paths to allow subclasses to reset any of their builtin fields back to the initial values.

Specified by:
  `clear` in interface `Message.Builder`
Specified by:
  `clear` in interface `MessageLite.Builder`
Overrides:
  `clear` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessage.Builder<BuilderType>>`

### internalGetFieldAccessorTable

protected abstract GeneratedMessage.FieldAccessorTable internalGetFieldAccessorTable()
Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.

### getDescriptorForType

public Descriptors.Descriptor getDescriptorForType()
Description copied from interface: `Message.Builder`
Get the message's type's descriptor. See `MessageOrBuilder.getDescriptorForType()`.

### getAllFields

public Map<Descriptors.FieldDescriptor,Object> getAllFields()
Description copied from interface: `MessageOrBuilder`
Returns a collection of all the fields in this message which are set and their corresponding values. A singular ("required" or "optional") field is set iff hasField() returns true for that field. A "repeated" field is set iff getRepeatedFieldCount() is greater than zero. The values are exactly what would be returned by calling `MessageOrBuilder.getField(Descriptors.FieldDescriptor)` for each field. The map is guaranteed to be a sorted map, so iterating over it will return fields in order by field number.
If this is for a builder, the returned map may or may not reflect future changes to the builder. Either way, the returned map is itself unmodifiable.

### newBuilderForField

public Message.Builder newBuilderForField(Descriptors.FieldDescriptor field)
Description copied from interface: `Message.Builder`
Create a builder for messages of the appropriate type for the given field. The builder is NOT nested in the current builder. However, messages built with the builder can then be passed to the `Message.Builder.setField(Descriptors.FieldDescriptor, Object)`, `Message.Builder.setRepeatedField(Descriptors.FieldDescriptor, int, Object)`, or `Message.Builder.addRepeatedField(Descriptors.FieldDescriptor, Object)` method of the current builder.

To obtain a builder nested in the current builder, use `Message.Builder.getFieldBuilder(Descriptors.FieldDescriptor)` instead.

### getFieldBuilder

public Message.Builder getFieldBuilder(Descriptors.FieldDescriptor field)
Description copied from interface: `Message.Builder`
Get a nested builder instance for the given field.

Normally, we hold a reference to the immutable message object for the message type field. Some implementations (the generated message builders) can also hold a reference to the builder object (a nested builder) for the field.

If the field is already backed up by a nested builder, the nested builder is returned. Otherwise, a new field builder is created and returned. The original message field (if one exists) is merged into the field builder, which is then nested into its parent builder.

Specified by:
  `getFieldBuilder` in interface `Message.Builder`
Overrides:
  `getFieldBuilder` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessage.Builder<BuilderType>>`

### getRepeatedFieldBuilder

public Message.Builder getRepeatedFieldBuilder(Descriptors.FieldDescriptor field, int index)
Description copied from interface: `Message.Builder`
Get a nested builder instance for the given repeated field instance.

Normally, we hold a reference to the immutable message object for the message type field. Some implementations (the generated message builders) can also hold a reference to the builder object (a nested builder) for the field.

If the field is already backed up by a nested builder, the nested builder is returned. Otherwise, a new field builder is created and returned. The original message field (if one exists) is merged into the field builder, which is then nested into its parent builder.

Specified by:
  `getRepeatedFieldBuilder` in interface `Message.Builder`
Overrides:
  `getRepeatedFieldBuilder` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessage.Builder<BuilderType>>`

### hasOneof

public boolean hasOneof(Descriptors.OneofDescriptor oneof)
Description copied from class: `AbstractMessage.Builder`
TODO(jieluo): Clear it when all subclasses have implemented this method.

Specified by:
  `hasOneof` in interface `MessageOrBuilder`
Overrides:
  `hasOneof` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessage.Builder<BuilderType>>`

### getOneofFieldDescriptor

public Descriptors.FieldDescriptor getOneofFieldDescriptor(Descriptors.OneofDescriptor oneof)
Description copied from class: `AbstractMessage.Builder`
TODO(jieluo): Clear it when all subclasses have implemented this method.

Specified by:
  `getOneofFieldDescriptor` in interface `MessageOrBuilder`
Overrides:
  `getOneofFieldDescriptor` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessage.Builder<BuilderType>>`

### hasField

public boolean hasField(Descriptors.FieldDescriptor field)
Description copied from interface: `MessageOrBuilder`
Returns true if the given field is set. This is exactly equivalent to calling the generated "has" accessor method corresponding to the field.

### getField

public Object getField(Descriptors.FieldDescriptor field)
Description copied from interface: `MessageOrBuilder`
Obtains the value of the given field, or the default value if it is not set. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned. For repeated fields, a java.util.List is returned.

### setField

public BuilderType setField(Descriptors.FieldDescriptor field, Object value)
Description copied from interface: `Message.Builder`
Sets a field to the given value. The value must be of the correct type for this field, that is, the same type that `MessageOrBuilder.getField(Descriptors.FieldDescriptor)` returns.

### clearField

public BuilderType clearField(Descriptors.FieldDescriptor field)
Description copied from interface: `Message.Builder`
Clears the field. This is exactly equivalent to calling the generated "clear" accessor method corresponding to the field.

### clearOneof

public BuilderType clearOneof(Descriptors.OneofDescriptor oneof)
Description copied from class: `AbstractMessage.Builder`
TODO(jieluo): Clear it when all subclasses have implemented this method.

Specified by:
  `clearOneof` in interface `Message.Builder`
Overrides:
  `clearOneof` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessage.Builder<BuilderType>>`

### getRepeatedFieldCount

public int getRepeatedFieldCount(Descriptors.FieldDescriptor field)
Description copied from interface: `MessageOrBuilder`
Gets the number of elements of a repeated field. This is exactly equivalent to calling the generated "Count" accessor method corresponding to the field.

### getRepeatedField

public Object getRepeatedField(Descriptors.FieldDescriptor field, int index)
Description copied from interface: `MessageOrBuilder`
Gets an element of a repeated field. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned.

### setRepeatedField

public BuilderType setRepeatedField(Descriptors.FieldDescriptor field, int index, Object value)
Description copied from interface: `Message.Builder`
Sets an element of a repeated field to the given value. The value must be of the correct type for this field; that is, the same type that `MessageOrBuilder.getRepeatedField(Descriptors.FieldDescriptor,int)` returns.

### addRepeatedField

public BuilderType addRepeatedField(Descriptors.FieldDescriptor field, Object value)
Description copied from interface: `Message.Builder`
Like `setRepeatedField`, but appends the value as a new element.

### setUnknownFields

public BuilderType setUnknownFields(UnknownFieldSet unknownFields)
Description copied from interface: `Message.Builder`
Set the `UnknownFieldSet` for this message.

### mergeUnknownFields

public BuilderType mergeUnknownFields(UnknownFieldSet unknownFields)
Description copied from interface: `Message.Builder`
Merge some unknown fields into the `UnknownFieldSet` for this message.

Specified by:
  `mergeUnknownFields` in interface `Message.Builder`
Overrides:
  `mergeUnknownFields` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessage.Builder<BuilderType>>`

### isInitialized

public boolean isInitialized()
Description copied from interface: `MessageLiteOrBuilder`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.

See also: `MessageOrBuilder.getInitializationErrorString()`

### getUnknownFields

public final UnknownFieldSet getUnknownFields()
Description copied from interface: `MessageOrBuilder`
Get the `UnknownFieldSet` for this message.

### parseUnknownField

protected boolean parseUnknownField(CodedInputStream input, UnknownFieldSet.Builder unknownFields, ExtensionRegistryLite extensionRegistry, int tag) throws IOException
Called by subclasses to parse an unknown field.

Returns:
  `true` unless the tag is an end-group tag.
Throws:
  `IOException`

### getParentForChildren

protected GeneratedMessage.BuilderParent getParentForChildren()
Gets the `GeneratedMessage.BuilderParent` for giving to our children.

Returns:
  The builder parent for our children.

### onChanged

protected final void onChanged()
Called when a the builder or one of its nested children has changed and any parent should be notified of its invalidation.

### internalGetMapField

protected MapField internalGetMapField(int fieldNumber)
Gets the map field with the given field number. This method should be overridden in the generated message class if the message contains map fields.

Unlike other field types, reflection support for map fields can't be implemented based on generated public API because we need to access a map field as a list in reflection API but the generated API only allows us to access it as a map. This method returns the underlying map field directly and thus enables us to access the map field as a list.

### internalGetMutableMapField

protected MapField internalGetMutableMapField(int fieldNumber)
Like `internalGetMapField(int)` but return a mutable version.